/**
 * A class that provides functionalities to take an input text and generates a Pig Latin
 * version of the sentence.
 * 
 * @author Abu Zafar M. Shahriar    
 * @version 09/21/2012
 */
public class PigLatinGenerator
{
    //suffix to be added at the end of the word
    private final static String vowelSuffix = "way";
    private final static String consonentSuffix = "ay";
    /**
     * Constructor for objects of class PigLatinGenerator
     */
    public PigLatinGenerator()
    {
    }
    
    /**
     * Check if a letter is a vowel or not
     * 
     * @param   letter   a letter to be checked 
     * @return     true or false depending on whether the letter is a vowel or not
     */

    public boolean isVowel(char letter)
    {
        boolean result = false; //result of test initially false
        String vowels = "AEIOUaeiou"; //a string composed of all possible vowels
        
        int index = vowels.indexOf(letter);
        if(index == -1)//the letter is not present in the string of vowels
            return false;
        else
            return true;
    }

  
    /**
     * Generate Pig Latin form of a single word
     * 
     * @param   word    a word to be converted 
     * @return     the converted word
     */

    public String generatePigLatinWord(String word)
    {
        String newword;//the piglatin word
        char c = word.charAt(0);//get the first character of the word
        if(Character.isLetter(c))// if it is a letter
        {
            if(isVowel(c))//if the letter is a vowel
            {
                newword = word + vowelSuffix;//append the appropriate sufffix
            }
            else
            {
                //move the first letter to the end and append the aprpopriate suffix
                newword = word.substring(1) + word.substring(0,1) + consonentSuffix;
            }
        }
        else
        {
            // no change to the original word
            newword = new String(word);
        }
        return newword;
    }

    /**
     * Generate Pig Latin form a series of words
     * 
     * @return     Pig Latin words
     */
    
   public  String generatePigLatinText(String text)
   {
       int startindex = 0;//start index of the word, initially 0

       //get an input text
 
       int endindex = text.indexOf(" ",startindex);//end index of the word terminated by a space
 
       //loop through each word of the string separated by a space
       //and convert the word to its Pig Latin form
       String outputtext = "";// the Pig Latin text 
       while(endindex != -1)
       {
           String nextword = text.substring(startindex,endindex);// extract the next word
           outputtext = outputtext + generatePigLatinWord(nextword) + " ";// genrate the Pig Latin and add it
                                                                            //to Pig Latin text genrated to far
           startindex = endindex + 1;//update the start index to point to the start of the next word
           endindex = text.indexOf(" ",startindex);//get the endindex for the next word
       }
       //for the last word in the text, as the word is not followed by a space
       String lastword = text.substring(startindex,text.length());
       outputtext = outputtext + generatePigLatinWord(lastword);

       return outputtext; 
   }
}
